﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.47
@EndOfDesignText@
#if B4A
'ignore DIP related warnings as they are not relevant when working with BitmapCreator.
#IgnoreWarnings: 6
#end if
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
Sub Class_Globals
	Public X2 As X2Utils
	Private xui As XUI 'ignore
	Public world As B2World

	Private ivForeground As B4XView
	Public ivBackground As B4XView
	
	Public lblStats As B4XView
	
	Public TileMap As X2TileMap
	Public Const ObjectLayer As String = "Object Layer 1"
	
	Private GameOver As Boolean
	
	Private ground As X2BodyWrapper
	Public TotalWidth As Float
	Public WorldHeight As Float
	Private WorldWidth As Float
	
	Public RightDown, LeftDown, Q As Boolean
	
	Private ball1, ball2, ball3 As X2BodyWrapper

	Private MouseJoint As MouseJoint 'ignore
	Private PanelForTouch As B4XView
	
End Sub

Public Sub Initialize (Parent As B4XView)
	Parent.LoadLayout("1")
	world.Initialize("world", world.CreateVec2(0, 0))
	X2.Initialize(Me, ivForeground, world)
	Dim ratio As Float = ivForeground.Width / ivForeground.Height
	
	WorldHeight = 20
	TotalWidth = WorldHeight * 1.5
	Dim WorldWidth As Float = WorldHeight * ratio
	X2.ConfigureDimensions(X2.CreateVec2(WorldWidth / 2, WorldHeight / 2), WorldWidth)
'	'
'	X2.PositionIterations = 30
'	X2.VelocityIterations = 30
'	'
	lblStats.TextColor = xui.Color_Black
	lblStats.Color = 0x88ffffff
	lblStats.Font = xui.CreateDefaultBoldFont(20)
	'
	MouseJoint.Initialize(Me)
	'
	'comment to disable debug drawing
	X2.EnableDebugDraw
	'
	'
End Sub

Public Sub Start
	If X2.IsRunning Then Return
	'
	X2.Reset

	'
	GameOver = False
	'
	CreateStaticBackground
	'
	TileMap.Initialize(X2, File.DirAssets, "thing.json", Null)
	TileMap.SetSingleTileDimensionsInMeters(WorldHeight / TileMap.TilesPerColumn, WorldHeight / TileMap.TilesPerColumn)
	TileMap.PrepareObjectsDef(ObjectLayer)
	
	'
	Dim ol As X2ObjectsLayer = TileMap.Layers.Get(ObjectLayer)
	' something to grap
	For Each template As X2TileObjectTemplate In ol.ObjectsById.Values

		Dim bw As X2BodyWrapper = TileMap.CreateObject(template)
		If bw.Name = "ball1" Then
			ball1 = bw
		Else If bw.Name = "ball2" Then
			ball2 = bw				
		Else If bw.Name = "ball3" Then
			ball3 = bw	
		Else If bw.Name = "rotor" Then
			bw.Body.AngularVelocity = cPI
		End If

	Next
	' bold balls together
	Dim DistJdDef As B2DistanceJointDef
	' 1+2
	DistJdDef.Initialize( ball1.Body, ball2.Body, ball1.Body.Position, ball2.Body.Position )
	world.CreateJoint( DistJdDef )
	' 2+3
	DistJdDef.Initialize( ball3.Body, ball2.Body, ball3.Body.Position, ball2.Body.Position )
	world.CreateJoint( DistJdDef )
	' 3+1
	DistJdDef.Initialize( ball3.Body, ball1.Body, ball3.Body.Position, ball1.Body.Position )
	world.CreateJoint( DistJdDef )
	' initial movment
	ball1.Body.LinearVelocity = X2.CreateVec2( -30, 20 ) 
	' 
	X2.Start
End Sub

Private Sub Game_Over(ft As X2FutureTask)
	'
	' stop and restart
	X2.Stop
	Sleep(100)
	Start 
	'
End Sub

Private Sub CreateStaticBackground
	Dim bc As BitmapCreator
	bc.Initialize(ivBackground.Width / xui.Scale / 2, ivBackground.Height / xui.Scale / 2)
	bc.FillGradient(Array As Int(0xFF006EFF, 0xFF00DAAD), bc.TargetRect, "TOP_BOTTOM")
	X2.SetBitmapWithFitOrFill(ivBackground, bc.Bitmap)
End Sub




Private Sub PanelForTouch_Touch (Action As Int, X As Float, Y As Float)
	X = Max(0, Min(X, PanelForTouch.Width))
	Y = Max(0, Min(Y, PanelForTouch.Height))
	'
	Select Action
		Case PanelForTouch.TOUCH_ACTION_DOWN
			'
			MouseJoint.Create( X,Y )
			'
		Case PanelForTouch.TOUCH_ACTION_MOVE
			'
			MouseJoint.Move( X,Y )
			'
		Case PanelForTouch.TOUCH_ACTION_UP
			'
			MouseJoint.Destroy
			' 
	End Select
	'
End Sub

Public Sub Tick (GS As X2GameStep)
	'
	If GameOver Then Return
	'
	If q Then
		X2.AddFutureTask(Me, "game_over", 500, Null)
		GameOver = True
	End If
	'

	If GS.ShouldDraw Then
		

	End If
		
End Sub


Sub ClipScreenCenterToMapArea (v As B2Vec2) As B2Vec2
	Dim ScreenHalfWidth As Double = X2.ScreenAABB.Width / 2
	Dim ScreenHalfHeight As Double = X2.ScreenAABB.Height / 2
	v.X = Max(ScreenHalfWidth, Min(TileMap.MapAABB.Width - ScreenHalfWidth, v.X))
	v.Y = Max(ScreenHalfHeight, Min(TileMap.MapAABB.Height - ScreenHalfHeight, v.Y))
	' Finale Screen Koordinaten
	Return v
End Sub


Public Sub Resize
	X2.ImageViewResized
End Sub

Public Sub DrawingComplete
	TileMap.DrawingComplete
End Sub

'Return True to stop the game loop
Public Sub BeforeTimeStep (GS As X2GameStep) As Boolean
	Return False
End Sub


